/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;

public interface ClusterSchemaAccessor extends PAccessor {

	//Accessors to the JONASAUTOPKFIELD field
	public void paSetJONASAUTOPKFIELD(java.lang.Integer val) throws PException;
	public java.lang.Integer paGetJONASAUTOPKFIELD() throws PException;

	//Accessors to the jOnASName field
	public void paSetJOnASName(java.lang.String val) throws PException;
	public java.lang.String paGetJOnASName() throws PException;

	//Accessors to the number field
	public void paSetNumber(java.lang.String val) throws PException;
	public java.lang.String paGetNumber() throws PException;
}
