/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.naming.api.PBinder;
import org.objectweb.jorm.naming.api.PExceptionNaming;
import org.objectweb.jorm.api.PExceptionProtocol;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;
import org.objectweb.jorm.naming.api.PNameCoder;
import org.objectweb.jorm.api.PSerializable;
import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PAccessorGen;
import org.objectweb.jorm.api.PClassMapping;

public class JE2_CreditCardSerializable implements PSerializable, JE2_CreditCardAccessor {

	//the pname of the object
	protected String pName;
	
		protected java.lang.Integer JONASAUTOPKFIELD;
			protected java.lang.String creditOrganization;
			protected  String customer;
			protected java.util.Date expirationDate;
			protected java.lang.String nameOnCard;
			protected java.lang.String number;
	
	public String setPName(PName pName){
		if(pName.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				this.pName  = pName.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			this.pName = "null";
		}
		return this.pName;
	}
	
	public PName getPName(PBinder pnc) throws PExceptionNaming{
		try{
			return pnc.decodeString(pName);
		}catch (Exception e) {
              throw new PExceptionNaming("Cannot decode to a PName: " + e.getMessage());
        }
	}
	
	public String getClassName(){
		return "jorm.JE2_CreditCard";
	}
	

	public void paSetJONASAUTOPKFIELD(java.lang.Integer val){
		JONASAUTOPKFIELD = val;
	}
	public java.lang.Integer paGetJONASAUTOPKFIELD() {
		return JONASAUTOPKFIELD;
	}

	public void paSetCreditOrganization(java.lang.String val){
		creditOrganization = val;
	}
	public java.lang.String paGetCreditOrganization() {
		return creditOrganization;
	}

	public void paSetCustomer(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				customer = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			customer = "null";
		}
	}
	
	public PName paGetCustomer(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("customer");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(customer);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetExpirationDate(java.util.Date val){
		expirationDate = val;
	}
	public java.util.Date paGetExpirationDate() {
		return expirationDate;
	}

	public void paSetNameOnCard(java.lang.String val){
		nameOnCard = val;
	}
	public java.lang.String paGetNameOnCard() {
		return nameOnCard;
	}

	public void paSetNumber(java.lang.String val){
		number = val;
	}
	public java.lang.String paGetNumber() {
		return number;
	}

	public Object getMemoryInstance(){
		return this;
	}
	
	
	public String toString(){
		StringBuffer s = new StringBuffer();
		s.append("data(");
					s.append(JONASAUTOPKFIELD + ",  ");
					s.append(creditOrganization + ",  ");
					s.append(customer + ",  ");
					s.append(expirationDate + ",  ");
					s.append(nameOnCard + ",  ");
					s.append(number + ",  ");
				s.append(pName + ")");
		return s.toString();
	}
	
	
	public void read(PClassMapping pcm, PAccessor pa) throws PException{
		JE2_CreditCardAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PException("Accessor must not be null");
		else if (pa instanceof JE2_CreditCardAccessor)
			paccessor = (JE2_CreditCardAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PException("Wrong type of accessor: " + pa);
	 	try {	
			if(paccessor != null){
											paccessor.paSetJONASAUTOPKFIELD(paGetJONASAUTOPKFIELD());
															paccessor.paSetCreditOrganization(paGetCreditOrganization());
															paccessor.paSetCustomer(paGetCustomer(pcm), null);
															paccessor.paSetExpirationDate(paGetExpirationDate());
															paccessor.paSetNameOnCard(paGetNameOnCard());
															paccessor.paSetNumber(paGetNumber());
							 			}
 			else{
	  		 			        		//paccessorGen.paSetOintField("JONASAUTOPKFIELD", paGetJONASAUTOPKFIELD(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("creditOrganization", paGetCreditOrganization(pcm), null);
	        			 						 			        		//paccessorGen.paSetDateField("expirationDate", paGetExpirationDate(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("nameOnCard", paGetNameOnCard(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("number", paGetNumber(pcm), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
	
	public void write(PClassMapping pcm, PAccessor pa) throws PException{
		JE2_CreditCardAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PExceptionProtocol("Accessor must not be null");
		else if (pa instanceof JE2_CreditCardAccessor)
			paccessor = (JE2_CreditCardAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PExceptionProtocol("Wrong type of accessor: " + pa);
		try {	
			if(paccessor != null){
											paSetJONASAUTOPKFIELD(paccessor.paGetJONASAUTOPKFIELD());
															paSetCreditOrganization(paccessor.paGetCreditOrganization());
															paSetCustomer(paccessor.paGetCustomer(pcm), null);
															paSetExpirationDate(paccessor.paGetExpirationDate());
															paSetNameOnCard(paccessor.paGetNameOnCard());
															paSetNumber(paccessor.paGetNumber());
							 			}
 			else{
	  		 				        	//	paSetOintField(JONASAUTOPKFIELD, paccessorGen.paGetJONASAUTOPKFIELD());
        		//paSetOintField("JONASAUTOPKFIELD", paccessorGen.paGetOintField("JONASAUTOPKFIELD"));
        		//paSetJONASAUTOPKFIELD(paccessorGen.paGetOintField("JONASAUTOPKFIELD"), null);
	        			 				        	//	paSetStringField(creditOrganization, paccessorGen.paGetCreditOrganization());
        		//paSetStringField("creditOrganization", paccessorGen.paGetStringField("creditOrganization"));
        		//paSetCreditOrganization(paccessorGen.paGetStringField("creditOrganization"), null);
	        			 						 				        	//	paSetDateField(expirationDate, paccessorGen.paGetExpirationDate());
        		//paSetDateField("expirationDate", paccessorGen.paGetDateField("expirationDate"));
        		//paSetExpirationDate(paccessorGen.paGetDateField("expirationDate"), null);
	        			 				        	//	paSetStringField(nameOnCard, paccessorGen.paGetNameOnCard());
        		//paSetStringField("nameOnCard", paccessorGen.paGetStringField("nameOnCard"));
        		//paSetNameOnCard(paccessorGen.paGetStringField("nameOnCard"), null);
	        			 				        	//	paSetStringField(number, paccessorGen.paGetNumber());
        		//paSetStringField("number", paccessorGen.paGetStringField("number"));
        		//paSetNumber(paccessorGen.paGetStringField("number"), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
}